# coding: utf-8

"""
    Intrinio API

    Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.  # noqa: E501

    OpenAPI spec version: 2.61.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from intrinio_sdk.models.company_summary import CompanySummary  # noqa: F401,E501


class ZacksSalesEstimate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'company': 'CompanySummary',
        'date': 'date',
        'fiscal_year': 'int',
        'fiscal_period': 'str',
        'calendar_year': 'int',
        'calendar_period': 'str',
        'count': 'int',
        'mean': 'float',
        'median': 'float',
        'high': 'float',
        'low': 'float',
        'standard_deviation': 'float',
        'analyst_revisions_percent_change_1w': 'float',
        'analyst_revisions_up_1w': 'float',
        'analyst_revisions_down_1w': 'float',
        'analyst_revisions_percent_change_1m': 'float',
        'analyst_revisions_up_1m': 'float',
        'analyst_revisions_down_1m': 'float',
        'analyst_revisions_percent_change_3m': 'float',
        'analyst_revisions_up_3m': 'float',
        'analyst_revisions_down_3m': 'float'
    }

    attribute_map = {
        'company': 'company',
        'date': 'date',
        'fiscal_year': 'fiscal_year',
        'fiscal_period': 'fiscal_period',
        'calendar_year': 'calendar_year',
        'calendar_period': 'calendar_period',
        'count': 'count',
        'mean': 'mean',
        'median': 'median',
        'high': 'high',
        'low': 'low',
        'standard_deviation': 'standard_deviation',
        'analyst_revisions_percent_change_1w': 'analyst_revisions_percent_change_1w',
        'analyst_revisions_up_1w': 'analyst_revisions_up_1w',
        'analyst_revisions_down_1w': 'analyst_revisions_down_1w',
        'analyst_revisions_percent_change_1m': 'analyst_revisions_percent_change_1m',
        'analyst_revisions_up_1m': 'analyst_revisions_up_1m',
        'analyst_revisions_down_1m': 'analyst_revisions_down_1m',
        'analyst_revisions_percent_change_3m': 'analyst_revisions_percent_change_3m',
        'analyst_revisions_up_3m': 'analyst_revisions_up_3m',
        'analyst_revisions_down_3m': 'analyst_revisions_down_3m'
    }

    def __init__(self, company=None, date=None, fiscal_year=None, fiscal_period=None, calendar_year=None, calendar_period=None, count=None, mean=None, median=None, high=None, low=None, standard_deviation=None, analyst_revisions_percent_change_1w=None, analyst_revisions_up_1w=None, analyst_revisions_down_1w=None, analyst_revisions_percent_change_1m=None, analyst_revisions_up_1m=None, analyst_revisions_down_1m=None, analyst_revisions_percent_change_3m=None, analyst_revisions_up_3m=None, analyst_revisions_down_3m=None):  # noqa: E501
        """ZacksSalesEstimate - a model defined in Swagger"""  # noqa: E501

        self._company = None
        self._date = None
        self._fiscal_year = None
        self._fiscal_period = None
        self._calendar_year = None
        self._calendar_period = None
        self._count = None
        self._mean = None
        self._median = None
        self._high = None
        self._low = None
        self._standard_deviation = None
        self._analyst_revisions_percent_change_1w = None
        self._analyst_revisions_up_1w = None
        self._analyst_revisions_down_1w = None
        self._analyst_revisions_percent_change_1m = None
        self._analyst_revisions_up_1m = None
        self._analyst_revisions_down_1m = None
        self._analyst_revisions_percent_change_3m = None
        self._analyst_revisions_up_3m = None
        self._analyst_revisions_down_3m = None
        self.discriminator = None

        if company is not None:
            self.company = company
        if date is not None:
            self.date = date
        if fiscal_year is not None:
            self.fiscal_year = fiscal_year
        if fiscal_period is not None:
            self.fiscal_period = fiscal_period
        if calendar_year is not None:
            self.calendar_year = calendar_year
        if calendar_period is not None:
            self.calendar_period = calendar_period
        if count is not None:
            self.count = count
        if mean is not None:
            self.mean = mean
        if median is not None:
            self.median = median
        if high is not None:
            self.high = high
        if low is not None:
            self.low = low
        if standard_deviation is not None:
            self.standard_deviation = standard_deviation
        if analyst_revisions_percent_change_1w is not None:
            self.analyst_revisions_percent_change_1w = analyst_revisions_percent_change_1w
        if analyst_revisions_up_1w is not None:
            self.analyst_revisions_up_1w = analyst_revisions_up_1w
        if analyst_revisions_down_1w is not None:
            self.analyst_revisions_down_1w = analyst_revisions_down_1w
        if analyst_revisions_percent_change_1m is not None:
            self.analyst_revisions_percent_change_1m = analyst_revisions_percent_change_1m
        if analyst_revisions_up_1m is not None:
            self.analyst_revisions_up_1m = analyst_revisions_up_1m
        if analyst_revisions_down_1m is not None:
            self.analyst_revisions_down_1m = analyst_revisions_down_1m
        if analyst_revisions_percent_change_3m is not None:
            self.analyst_revisions_percent_change_3m = analyst_revisions_percent_change_3m
        if analyst_revisions_up_3m is not None:
            self.analyst_revisions_up_3m = analyst_revisions_up_3m
        if analyst_revisions_down_3m is not None:
            self.analyst_revisions_down_3m = analyst_revisions_down_3m

    @property
    def company(self):
        """Gets the company of this ZacksSalesEstimate.  # noqa: E501


        :return: The company of this ZacksSalesEstimate.  # noqa: E501
        :rtype: CompanySummary
        """
        return self._company
        
    @property
    def company_dict(self):
        """Gets the company of this ZacksSalesEstimate.  # noqa: E501


        :return: The company of this ZacksSalesEstimate.  # noqa: E501
        :rtype: CompanySummary
        """

        result = None

        value = self.company
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'company': value }

        
        return result
        

    @company.setter
    def company(self, company):
        """Sets the company of this ZacksSalesEstimate.


        :param company: The company of this ZacksSalesEstimate.  # noqa: E501
        :type: CompanySummary
        """

        self._company = company

    @property
    def date(self):
        """Gets the date of this ZacksSalesEstimate.  # noqa: E501

        The period end date  # noqa: E501

        :return: The date of this ZacksSalesEstimate.  # noqa: E501
        :rtype: date
        """
        return self._date
        
    @property
    def date_dict(self):
        """Gets the date of this ZacksSalesEstimate.  # noqa: E501

        The period end date as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The date of this ZacksSalesEstimate.  # noqa: E501
        :rtype: date
        """

        result = None

        value = self.date
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'date': value }

        
        return result
        

    @date.setter
    def date(self, date):
        """Sets the date of this ZacksSalesEstimate.

        The period end date  # noqa: E501

        :param date: The date of this ZacksSalesEstimate.  # noqa: E501
        :type: date
        """

        self._date = date

    @property
    def fiscal_year(self):
        """Gets the fiscal_year of this ZacksSalesEstimate.  # noqa: E501

        The company’s fiscal year for the reported period  # noqa: E501

        :return: The fiscal_year of this ZacksSalesEstimate.  # noqa: E501
        :rtype: int
        """
        return self._fiscal_year
        
    @property
    def fiscal_year_dict(self):
        """Gets the fiscal_year of this ZacksSalesEstimate.  # noqa: E501

        The company’s fiscal year for the reported period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The fiscal_year of this ZacksSalesEstimate.  # noqa: E501
        :rtype: int
        """

        result = None

        value = self.fiscal_year
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'fiscal_year': value }

        
        return result
        

    @fiscal_year.setter
    def fiscal_year(self, fiscal_year):
        """Sets the fiscal_year of this ZacksSalesEstimate.

        The company’s fiscal year for the reported period  # noqa: E501

        :param fiscal_year: The fiscal_year of this ZacksSalesEstimate.  # noqa: E501
        :type: int
        """

        self._fiscal_year = fiscal_year

    @property
    def fiscal_period(self):
        """Gets the fiscal_period of this ZacksSalesEstimate.  # noqa: E501

        The company’s fiscal quarter for the reported period  # noqa: E501

        :return: The fiscal_period of this ZacksSalesEstimate.  # noqa: E501
        :rtype: str
        """
        return self._fiscal_period
        
    @property
    def fiscal_period_dict(self):
        """Gets the fiscal_period of this ZacksSalesEstimate.  # noqa: E501

        The company’s fiscal quarter for the reported period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The fiscal_period of this ZacksSalesEstimate.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.fiscal_period
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'fiscal_period': value }

        
        return result
        

    @fiscal_period.setter
    def fiscal_period(self, fiscal_period):
        """Sets the fiscal_period of this ZacksSalesEstimate.

        The company’s fiscal quarter for the reported period  # noqa: E501

        :param fiscal_period: The fiscal_period of this ZacksSalesEstimate.  # noqa: E501
        :type: str
        """

        self._fiscal_period = fiscal_period

    @property
    def calendar_year(self):
        """Gets the calendar_year of this ZacksSalesEstimate.  # noqa: E501

        The closest calendar year for the company’s fiscal year  # noqa: E501

        :return: The calendar_year of this ZacksSalesEstimate.  # noqa: E501
        :rtype: int
        """
        return self._calendar_year
        
    @property
    def calendar_year_dict(self):
        """Gets the calendar_year of this ZacksSalesEstimate.  # noqa: E501

        The closest calendar year for the company’s fiscal year as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The calendar_year of this ZacksSalesEstimate.  # noqa: E501
        :rtype: int
        """

        result = None

        value = self.calendar_year
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'calendar_year': value }

        
        return result
        

    @calendar_year.setter
    def calendar_year(self, calendar_year):
        """Sets the calendar_year of this ZacksSalesEstimate.

        The closest calendar year for the company’s fiscal year  # noqa: E501

        :param calendar_year: The calendar_year of this ZacksSalesEstimate.  # noqa: E501
        :type: int
        """

        self._calendar_year = calendar_year

    @property
    def calendar_period(self):
        """Gets the calendar_period of this ZacksSalesEstimate.  # noqa: E501

        The closest calendar quarter for the company’s fiscal year  # noqa: E501

        :return: The calendar_period of this ZacksSalesEstimate.  # noqa: E501
        :rtype: str
        """
        return self._calendar_period
        
    @property
    def calendar_period_dict(self):
        """Gets the calendar_period of this ZacksSalesEstimate.  # noqa: E501

        The closest calendar quarter for the company’s fiscal year as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The calendar_period of this ZacksSalesEstimate.  # noqa: E501
        :rtype: str
        """

        result = None

        value = self.calendar_period
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'calendar_period': value }

        
        return result
        

    @calendar_period.setter
    def calendar_period(self, calendar_period):
        """Sets the calendar_period of this ZacksSalesEstimate.

        The closest calendar quarter for the company’s fiscal year  # noqa: E501

        :param calendar_period: The calendar_period of this ZacksSalesEstimate.  # noqa: E501
        :type: str
        """

        self._calendar_period = calendar_period

    @property
    def count(self):
        """Gets the count of this ZacksSalesEstimate.  # noqa: E501

        The number of estimates for the period  # noqa: E501

        :return: The count of this ZacksSalesEstimate.  # noqa: E501
        :rtype: int
        """
        return self._count
        
    @property
    def count_dict(self):
        """Gets the count of this ZacksSalesEstimate.  # noqa: E501

        The number of estimates for the period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The count of this ZacksSalesEstimate.  # noqa: E501
        :rtype: int
        """

        result = None

        value = self.count
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'count': value }

        
        return result
        

    @count.setter
    def count(self, count):
        """Sets the count of this ZacksSalesEstimate.

        The number of estimates for the period  # noqa: E501

        :param count: The count of this ZacksSalesEstimate.  # noqa: E501
        :type: int
        """

        self._count = count

    @property
    def mean(self):
        """Gets the mean of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate mean estimate for the period  # noqa: E501

        :return: The mean of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._mean
        
    @property
    def mean_dict(self):
        """Gets the mean of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate mean estimate for the period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The mean of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.mean
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'mean': value }

        
        return result
        

    @mean.setter
    def mean(self, mean):
        """Sets the mean of this ZacksSalesEstimate.

        The sales estimate mean estimate for the period  # noqa: E501

        :param mean: The mean of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._mean = mean

    @property
    def median(self):
        """Gets the median of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate median estimate for the period  # noqa: E501

        :return: The median of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._median
        
    @property
    def median_dict(self):
        """Gets the median of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate median estimate for the period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The median of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.median
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'median': value }

        
        return result
        

    @median.setter
    def median(self, median):
        """Sets the median of this ZacksSalesEstimate.

        The sales estimate median estimate for the period  # noqa: E501

        :param median: The median of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._median = median

    @property
    def high(self):
        """Gets the high of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate high estimate for the period  # noqa: E501

        :return: The high of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._high
        
    @property
    def high_dict(self):
        """Gets the high of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate high estimate for the period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The high of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.high
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'high': value }

        
        return result
        

    @high.setter
    def high(self, high):
        """Sets the high of this ZacksSalesEstimate.

        The sales estimate high estimate for the period  # noqa: E501

        :param high: The high of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._high = high

    @property
    def low(self):
        """Gets the low of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate low estimate for the period  # noqa: E501

        :return: The low of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._low
        
    @property
    def low_dict(self):
        """Gets the low of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate low estimate for the period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The low of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.low
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'low': value }

        
        return result
        

    @low.setter
    def low(self, low):
        """Sets the low of this ZacksSalesEstimate.

        The sales estimate low estimate for the period  # noqa: E501

        :param low: The low of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._low = low

    @property
    def standard_deviation(self):
        """Gets the standard_deviation of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate standard deviation estimate for the period  # noqa: E501

        :return: The standard_deviation of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._standard_deviation
        
    @property
    def standard_deviation_dict(self):
        """Gets the standard_deviation of this ZacksSalesEstimate.  # noqa: E501

        The sales estimate standard deviation estimate for the period as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The standard_deviation of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.standard_deviation
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'standard_deviation': value }

        
        return result
        

    @standard_deviation.setter
    def standard_deviation(self, standard_deviation):
        """Sets the standard_deviation of this ZacksSalesEstimate.

        The sales estimate standard deviation estimate for the period  # noqa: E501

        :param standard_deviation: The standard_deviation of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._standard_deviation = standard_deviation

    @property
    def analyst_revisions_percent_change_1w(self):
        """Gets the analyst_revisions_percent_change_1w of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions percent change in estimate for the period of 1 week.  # noqa: E501

        :return: The analyst_revisions_percent_change_1w of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_percent_change_1w
        
    @property
    def analyst_revisions_percent_change_1w_dict(self):
        """Gets the analyst_revisions_percent_change_1w of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions percent change in estimate for the period of 1 week. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_percent_change_1w of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_percent_change_1w
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_percent_change_1w': value }

        
        return result
        

    @analyst_revisions_percent_change_1w.setter
    def analyst_revisions_percent_change_1w(self, analyst_revisions_percent_change_1w):
        """Sets the analyst_revisions_percent_change_1w of this ZacksSalesEstimate.

        The analyst revisions percent change in estimate for the period of 1 week.  # noqa: E501

        :param analyst_revisions_percent_change_1w: The analyst_revisions_percent_change_1w of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_percent_change_1w = analyst_revisions_percent_change_1w

    @property
    def analyst_revisions_up_1w(self):
        """Gets the analyst_revisions_up_1w of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going up for the period of 1 week.  # noqa: E501

        :return: The analyst_revisions_up_1w of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_up_1w
        
    @property
    def analyst_revisions_up_1w_dict(self):
        """Gets the analyst_revisions_up_1w of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going up for the period of 1 week. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_up_1w of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_up_1w
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_up_1w': value }

        
        return result
        

    @analyst_revisions_up_1w.setter
    def analyst_revisions_up_1w(self, analyst_revisions_up_1w):
        """Sets the analyst_revisions_up_1w of this ZacksSalesEstimate.

        The analyst revisions going up for the period of 1 week.  # noqa: E501

        :param analyst_revisions_up_1w: The analyst_revisions_up_1w of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_up_1w = analyst_revisions_up_1w

    @property
    def analyst_revisions_down_1w(self):
        """Gets the analyst_revisions_down_1w of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going down for the period of 1 week.  # noqa: E501

        :return: The analyst_revisions_down_1w of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_down_1w
        
    @property
    def analyst_revisions_down_1w_dict(self):
        """Gets the analyst_revisions_down_1w of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going down for the period of 1 week. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_down_1w of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_down_1w
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_down_1w': value }

        
        return result
        

    @analyst_revisions_down_1w.setter
    def analyst_revisions_down_1w(self, analyst_revisions_down_1w):
        """Sets the analyst_revisions_down_1w of this ZacksSalesEstimate.

        The analyst revisions going down for the period of 1 week.  # noqa: E501

        :param analyst_revisions_down_1w: The analyst_revisions_down_1w of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_down_1w = analyst_revisions_down_1w

    @property
    def analyst_revisions_percent_change_1m(self):
        """Gets the analyst_revisions_percent_change_1m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions percent change in estimate for the period of 1 month.  # noqa: E501

        :return: The analyst_revisions_percent_change_1m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_percent_change_1m
        
    @property
    def analyst_revisions_percent_change_1m_dict(self):
        """Gets the analyst_revisions_percent_change_1m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions percent change in estimate for the period of 1 month. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_percent_change_1m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_percent_change_1m
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_percent_change_1m': value }

        
        return result
        

    @analyst_revisions_percent_change_1m.setter
    def analyst_revisions_percent_change_1m(self, analyst_revisions_percent_change_1m):
        """Sets the analyst_revisions_percent_change_1m of this ZacksSalesEstimate.

        The analyst revisions percent change in estimate for the period of 1 month.  # noqa: E501

        :param analyst_revisions_percent_change_1m: The analyst_revisions_percent_change_1m of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_percent_change_1m = analyst_revisions_percent_change_1m

    @property
    def analyst_revisions_up_1m(self):
        """Gets the analyst_revisions_up_1m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going up for the period of 1 month.  # noqa: E501

        :return: The analyst_revisions_up_1m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_up_1m
        
    @property
    def analyst_revisions_up_1m_dict(self):
        """Gets the analyst_revisions_up_1m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going up for the period of 1 month. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_up_1m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_up_1m
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_up_1m': value }

        
        return result
        

    @analyst_revisions_up_1m.setter
    def analyst_revisions_up_1m(self, analyst_revisions_up_1m):
        """Sets the analyst_revisions_up_1m of this ZacksSalesEstimate.

        The analyst revisions going up for the period of 1 month.  # noqa: E501

        :param analyst_revisions_up_1m: The analyst_revisions_up_1m of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_up_1m = analyst_revisions_up_1m

    @property
    def analyst_revisions_down_1m(self):
        """Gets the analyst_revisions_down_1m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going down for the period of 1 month.  # noqa: E501

        :return: The analyst_revisions_down_1m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_down_1m
        
    @property
    def analyst_revisions_down_1m_dict(self):
        """Gets the analyst_revisions_down_1m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going down for the period of 1 month. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_down_1m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_down_1m
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_down_1m': value }

        
        return result
        

    @analyst_revisions_down_1m.setter
    def analyst_revisions_down_1m(self, analyst_revisions_down_1m):
        """Sets the analyst_revisions_down_1m of this ZacksSalesEstimate.

        The analyst revisions going down for the period of 1 month.  # noqa: E501

        :param analyst_revisions_down_1m: The analyst_revisions_down_1m of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_down_1m = analyst_revisions_down_1m

    @property
    def analyst_revisions_percent_change_3m(self):
        """Gets the analyst_revisions_percent_change_3m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions percent change in estimate for the period of 3 months.  # noqa: E501

        :return: The analyst_revisions_percent_change_3m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_percent_change_3m
        
    @property
    def analyst_revisions_percent_change_3m_dict(self):
        """Gets the analyst_revisions_percent_change_3m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions percent change in estimate for the period of 3 months. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_percent_change_3m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_percent_change_3m
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_percent_change_3m': value }

        
        return result
        

    @analyst_revisions_percent_change_3m.setter
    def analyst_revisions_percent_change_3m(self, analyst_revisions_percent_change_3m):
        """Sets the analyst_revisions_percent_change_3m of this ZacksSalesEstimate.

        The analyst revisions percent change in estimate for the period of 3 months.  # noqa: E501

        :param analyst_revisions_percent_change_3m: The analyst_revisions_percent_change_3m of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_percent_change_3m = analyst_revisions_percent_change_3m

    @property
    def analyst_revisions_up_3m(self):
        """Gets the analyst_revisions_up_3m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going up for the period of 3 months.  # noqa: E501

        :return: The analyst_revisions_up_3m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_up_3m
        
    @property
    def analyst_revisions_up_3m_dict(self):
        """Gets the analyst_revisions_up_3m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going up for the period of 3 months. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_up_3m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_up_3m
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_up_3m': value }

        
        return result
        

    @analyst_revisions_up_3m.setter
    def analyst_revisions_up_3m(self, analyst_revisions_up_3m):
        """Sets the analyst_revisions_up_3m of this ZacksSalesEstimate.

        The analyst revisions going up for the period of 3 months.  # noqa: E501

        :param analyst_revisions_up_3m: The analyst_revisions_up_3m of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_up_3m = analyst_revisions_up_3m

    @property
    def analyst_revisions_down_3m(self):
        """Gets the analyst_revisions_down_3m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going down for the period of 3 months.  # noqa: E501

        :return: The analyst_revisions_down_3m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """
        return self._analyst_revisions_down_3m
        
    @property
    def analyst_revisions_down_3m_dict(self):
        """Gets the analyst_revisions_down_3m of this ZacksSalesEstimate.  # noqa: E501

        The analyst revisions going down for the period of 3 months. as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The analyst_revisions_down_3m of this ZacksSalesEstimate.  # noqa: E501
        :rtype: float
        """

        result = None

        value = self.analyst_revisions_down_3m
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'analyst_revisions_down_3m': value }

        
        return result
        

    @analyst_revisions_down_3m.setter
    def analyst_revisions_down_3m(self, analyst_revisions_down_3m):
        """Sets the analyst_revisions_down_3m of this ZacksSalesEstimate.

        The analyst revisions going down for the period of 3 months.  # noqa: E501

        :param analyst_revisions_down_3m: The analyst_revisions_down_3m of this ZacksSalesEstimate.  # noqa: E501
        :type: float
        """

        self._analyst_revisions_down_3m = analyst_revisions_down_3m

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ZacksSalesEstimate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
